petsc-3.12.1 2019-10-22
Report Typos and Errors

# MatSeqSELLSetPreallocation

For good matrix assembly performance the user should preallocate the matrix storage by setting the parameter nz (or the array nnz). By setting these parameters accurately, performance during matrix assembly can be increased significantly.

### Synopsis

    #include "petscmat.h"
    PetscErrorCode MatSeqSELLSetPreallocation(Mat B,PetscInt rlenmax,const PetscInt rlen[])

Collective

### Input Parameters

+ B - The matrix . nz - number of nonzeros per row (same for all rows) - nnz - array containing the number of nonzeros in the various rows (possibly different for each row) or NULL

### Notes

If nnz is given then nz is ignored.

Specify the preallocated storage with either nz or nnz (not both). Set nz=PETSC_DEFAULT and nnz=NULL for PETSc to control dynamic memory allocation. For large problems you MUST preallocate memory or you will get TERRIBLE performance, see the users' manual chapter on matrices.

You can call MatGetInfo() to get information on how effective the preallocation was; for example the fields mallocs,nz_allocated,nz_used,nz_unneeded; You can also run with the option -info and look for messages with the string malloc in them to see if additional memory allocation was needed.

Developers: Use nz of MAT_SKIP_ALLOCATION to not allocate any space for the matrix entries or columns indices.

The maximum number of nonzeos in any row should be as accurate as possible. If it is underestimated, you will get bad performance due to reallocation (MatSeqXSELLReallocateSELL).

.seealso: MatCreate(), MatCreateSELL(), MatSetValues(), MatGetInfo()

### Level

intermediate

### Location

src/mat/impls/sell/seq/sell.c

### Examples

src/ksp/ksp/examples/tutorials/ex2.c.html

### Implementations

MatSeqSELLSetPreallocation_SeqSELL in src/mat/impls/sell/seq/sell.c
Index of all Mat routines
Table of Contents for all manual pages
Index of all manual pages